Index: /branches/network/src/util/loading/resource_manager.cc
===================================================================
--- /branches/network/src/util/loading/resource_manager.cc	(revision 6692)
+++ /branches/network/src/util/loading/resource_manager.cc	(revision 6693)
@@ -575,139 +650,191 @@
 
 /**
- * unloads all alocated Memory of Resources with a pririty lower than prio
+ * @brief unloads all alocated Memory of Resources with a pririty lower than prio
  * @param prio The priority to delete
 */
 bool ResourceManager::unloadAllByPriority(ResourcePriority prio)
 {
-  std::list<Resource*>::iterator resource, pre;
-  pre = --this->resourceList.end();
   unsigned int removeCount;
   for (unsigned int round = 0; round < 3; round++)
   {
+    int index = this->resourceList.size() - 1;
     removeCount = 0;
-    while (pre != resourceList.end())
-    {
-      resource = pre;
-      pre--;
-        if ((*resource)->prio <= prio)
+    while (index >= 0)
+    {
+      if (this->resourceList[index]->prio <= prio)
+      {
+        if (this->resourceList[index]->count == 0)
+          unload(this->resourceList[index], prio);
+        else
         {
-          if ((*resource)->count == 0)
-            unload((*resource), prio);
-          else
-          {
+          if (round == 3)
             PRINTF(2)("unable to unload %s because there are still %d references to it\n",
-                     (*resource)->name, (*resource)->count);
-            removeCount++;
-          }
+                      this->resourceList[index]->name, this->resourceList[index]->count);
+          removeCount++;
         }
-     }
-     if (removeCount == 0) break;
-  }
-}
-
-
-/**
- * Searches for a Resource by some information
+      }
+      index--;
+    }
+    if (removeCount == 0) break;
+  }
+}
+
+
+/**
+ * @brief Searches for a Resource by some information
  * @param fileName: The name to look for
  * @param type the Type of resource to locate.
+ * @param param0: an additional option to parse (see the constuctors for more help)
  * @param param1: an additional option to parse (see the constuctors for more help)
  * @param param2: an additional option to parse (see the constuctors for more help)
- * @param param3: an additional option to parse (see the constuctors for more help)
  * @returns a Pointer to the Resource if found, NULL otherwise.
 */
 Resource* ResourceManager::locateResourceByInfo(const char* fileName, ResourceType type,
-                                                void* param1, void* param2, void* param3) const
-{
-  std::list<Resource*>::const_iterator resource;
+    const MultiType& param0, const MultiType& param1, const MultiType& param2) const
+{
+  std::vector<Resource*>::const_iterator resource;
   for (resource = this->resourceList.begin(); resource != this->resourceList.end(); resource++)
   {
     if ((*resource)->type == type && !strcmp(fileName, (*resource)->name))
-        {
-          bool match = false;
-
-          switch (type)
-            {
+    {
+      bool match = false;
+      switch (type)
+      {
 #ifndef NO_MODEL
-            case PRIM:
-            case OBJ:
-              if (!param1)
-                {
-                  if ((*resource)->modelSize == 1.0)
-                    match = true;
-                }
-              else if ((*resource)->modelSize == *(float*)param1)
-                match = true;
-              break;
-            case MD2:
-              if (!param1)
-                {
-                  if ((*resource)->secFileName == NULL)
-                    match = true;
-                }
-              else if (!strcmp((*resource)->secFileName, (const char*)param1))
-                match = true;
-              break;
+        case PRIM:
+        case OBJ:
+          if (param0 == MT_NULL)
+          {
+            if ((*resource)->param[0] == 1.0f)
+              match = true;
+          }
+          else if ((*resource)->param[0] == param0.getFloat())
+            match = true;
+          break;
+        case MD2:
+          if (param0 == MT_NULL)
+          {
+            if ((*resource)->param[0] == "")
+              match = true;
+          }
+          else if ((*resource)->param[0] == ((MultiType)param0).getString())
+            match = true;
+          break;
 #endif /* NO_MODEL */
 #ifndef NO_TEXT
-            case TTF:
-              if (param1 == NULL)
-                {
-                  if ((*resource)->ttfSize == FONT_DEFAULT_RENDER_SIZE)
-                    match = true;
-                }
-              else if ((*resource)->ttfSize == *(unsigned int*)param1)
-                match = true;
-              break;
+        case TTF:
+          if (param0 == MT_NULL)
+          {
+            if ((*resource)->param[0] == FONT_DEFAULT_RENDER_SIZE)
+              match = true;
+          }
+          else if ((*resource)->param[0] == param0.getInt())
+            match = true;
+          break;
 #endif /* NO_TEXT */
 #ifndef NO_SHADERS
-              case SHADER:
-                if (!param1)
-                {
-                  if ((*resource)->secFileName == NULL)
-                    match = true;
-                }
-                else if (!strcmp((*resource)->secFileName, (const char*)param1))
-                  match = true;
+        case SHADER:
+          if (param0 == MT_NULL)
+          {
+            if ((*resource)->param[0] == "")
+              match = true;
+          }
+          else if ((*resource)->param[0] == ((MultiType)param0).getString())
+            match = true;
 #endif /* NO_SHADERS */
 #ifndef NO_TEXTURES
-              case IMAGE:
-                if (!param1)
-                {
-                  if ((*resource)->texTarget == GL_TEXTURE_2D)
-                    match = true;
-                }
-                else if ((*resource)->texTarget ==  *(GLenum*)param1)
-                  match = true;
+        case IMAGE:
+          if (param0 == MT_NULL)
+          {
+            if ((*resource)->param[0] == GL_TEXTURE_2D)
+              match = true;
+          }
+          else if ((*resource)->param[0] ==  param0.getInt())
+            match = true;
 #endif /* NO_TEXTURES */
-            default:
-              match = true;
-              break;
-            }
-          if (match)
-            {
-              return (*resource);
-            }
-        }
-    }
+        default:
+          match = true;
+          break;
+      }
+      if (match)
+      {
+        return (*resource);
+      }
+    }
+  }
   return NULL;
 }
 
 /**
- * Searches for a Resource by Pointer
+ * @brief Searches for a Resource by Pointer
  * @param pointer the Pointer to search for
  * @returns a Pointer to the Resource if found, NULL otherwise.
-*/
+ */
 Resource* ResourceManager::locateResourceByPointer(const void* pointer) const
 {
   //  Resource* enumRes = resourceList->enumerate();
-  std::list<Resource*>::const_iterator resource;
+  std::vector<Resource*>::const_iterator resource;
   for (resource = this->resourceList.begin(); resource != this->resourceList.end(); resource++)
     if (pointer == (*resource)->pointer)
-        return (*resource);
+      return (*resource);
   return NULL;
 }
 
-/**
- * Checks if it is a Directory
+char* ResourceManager::toResourcableString(unsigned int i)
+{
+  int len = strlen(ResourceManager::ResourceTypeToChar(this->resourceList[i]->type));
+  len += strlen(this->resourceList[i]->name);
+  if (this->resourceList[i]->param[0].getString()) len += strlen(this->resourceList[i]->param[0].getString()) +1;
+  if (this->resourceList[i]->param[1].getString()) len += strlen(this->resourceList[i]->param[1].getString()) +1;
+  if (this->resourceList[i]->param[2].getString()) len += strlen(this->resourceList[i]->param[2].getString()) +1;
+  len += 10;
+  char* tmp = new char[len];
+  tmp[0] = '\0';
+  strcat( tmp, ResourceManager::ResourceTypeToChar(this->resourceList[i]->type));
+  strcat(tmp,",");
+  strcat (tmp, this->resourceList[i]->name);
+  if (this->resourceList[i]->param[0].getString() && this->resourceList[i]->param[0].getString() != '\0')
+  {
+    strcat(tmp,",");
+    strcat( tmp, this->resourceList[i]->param[0].getString());
+  }
+  if (this->resourceList[i]->param[1].getString() && this->resourceList[i]->param[1].getString() != '\0')
+  {
+    strcat(tmp,",");
+    strcat( tmp, this->resourceList[i]->param[1].getString());
+  }
+  if (this->resourceList[i]->param[2].getString() && this->resourceList[i]->param[2].getString() != '\0')
+  {
+    strcat(tmp,",");
+    strcat( tmp, this->resourceList[i]->param[2].getString());
+  }
+  return tmp;
+}
+
+/**
+ * @brief caches a Resource from a ResourceableString created with the toResourcableString-function
+ * @param resourceableString the String to cache the resource from.
+ */
+bool ResourceManager::fromResourceableString(const char* resourceableString)
+{
+  SubString splits(resourceableString, ',');
+  splits.debug();
+  if (splits.getCount() == 2)
+    this->cache(splits[1], ResourceManager::stringToResourceType(splits[0]),
+                RP_LEVEL);
+  else if (splits.getCount() == 3)
+    return this->cache(splits[1], ResourceManager::stringToResourceType(splits[0]),
+                RP_LEVEL, splits[2]);
+  else if (splits.getCount() == 4)
+    return this->cache(splits[1], ResourceManager::stringToResourceType(splits[0]),
+                RP_LEVEL, splits[2], splits[3]);
+  else if (splits.getCount() == 5)
+    return this->cache(splits[1], ResourceManager::stringToResourceType(splits[0]),
+                RP_LEVEL, splits[2], splits[3], splits[4]);
+}
+
+
+/**
+ * @brief Checks if it is a Directory
  * @param directoryName the Directory to check for
  * @returns true if it is a directory/symlink false otherwise
@@ -724,32 +851,32 @@
   if (directoryName[strlen(directoryName)-1] == '/' ||
       directoryName[strlen(directoryName)-1] == '\\')
-    {
-      tmpDirName = new char[strlen(directoryName)];
-      strncpy(tmpDirName, directoryName, strlen(directoryName)-1);
-      tmpDirName[strlen(directoryName)-1] = '\0';
-    }
-  else
-    {
-      tmpDirName = new char[strlen(directoryName)+1];
-      strcpy(tmpDirName, directoryName);
-    }
+  {
+    tmpDirName = new char[strlen(directoryName)];
+    strncpy(tmpDirName, directoryName, strlen(directoryName)-1);
+    tmpDirName[strlen(directoryName)-1] = '\0';
+  }
+  else
+  {
+    tmpDirName = new char[strlen(directoryName)+1];
+    strcpy(tmpDirName, directoryName);
+  }
 
   if(!stat(tmpDirName, &status))
-    {
-      if (status.st_mode & (S_IFDIR
+  {
+    if (status.st_mode & (S_IFDIR
 #ifndef __WIN32__
-                            | S_IFLNK
+                          | S_IFLNK
 #endif
-                            ))
-        {
-          delete[] tmpDirName;
-          return true;
-        }
-      else
-        {
-          delete[] tmpDirName;
-          return false;
-        }
-    }
+                         ))
+    {
+      delete[] tmpDirName;
+      return true;
+    }
+    else
+    {
+      delete[] tmpDirName;
+      return false;
+    }
+  }
   else
   {
@@ -760,5 +887,5 @@
 
 /**
- * Checks if the file is either a Regular file or a Symlink
+ * @brief Checks if the file is either a Regular file or a Symlink
  * @param fileName the File to check for
  * @returns true if it is a regular file/symlink, false otherwise
@@ -772,29 +899,29 @@
   struct stat status;
   if (!stat(tmpFileName, &status))
-    {
-      if (status.st_mode & (S_IFREG
+  {
+    if (status.st_mode & (S_IFREG
 #ifndef __WIN32__
-                            | S_IFLNK
+                          | S_IFLNK
 #endif
-                            ))
-        {
-          delete[] tmpFileName;
-          return true;
-        }
-      else
-        {
-          delete[] tmpFileName;
-          return false;
-        }
-    }
-  else
+                         ))
+    {
+      delete[] tmpFileName;
+      return true;
+    }
+    else
     {
       delete[] tmpFileName;
       return false;
     }
-}
-
-/**
- * touches a File on the disk (thereby creating it)
+  }
+  else
+  {
+    delete[] tmpFileName;
+    return false;
+  }
+}
+
+/**
+ * @brief touches a File on the disk (thereby creating it)
  * @param fileName The file to touch
 */
@@ -806,9 +933,9 @@
   FILE* stream;
   if( (stream = fopen (tmpName, "w")) == NULL)
-    {
-      PRINTF(1)("could not open %s fro writing\n", fileName);
-      delete[] tmpName;
-      return false;
-    }
+  {
+    PRINTF(1)("could not open %s fro writing\n", fileName);
+    delete[] tmpName;
+    return false;
+  }
   fclose(stream);
 
@@ -817,5 +944,5 @@
 
 /**
- * deletes a File from disk
+ * @brief deletes a File from disk
  * @param fileName the File to delete
 */
@@ -840,19 +967,19 @@
   char* retName;
   if (!strncmp(name, "~/", 2))
-    {
-      char tmpFileName[500];
+  {
+    char tmpFileName[500];
 #ifdef __WIN32__
-      strcpy(tmpFileName, getenv("USERPROFILE"));
+    strcpy(tmpFileName, getenv("USERPROFILE"));
 #else
-      strcpy(tmpFileName, getenv("HOME"));
+    strcpy(tmpFileName, getenv("HOME"));
 #endif
-      retName = new char[strlen(tmpFileName)+strlen(name)];
-      sprintf(retName, "%s%s", tmpFileName, name+1);
-    }
-  else
-    {
-      retName = new char[strlen(name)+1];
-      strcpy(retName, name);
-    }
+    retName = new char[strlen(tmpFileName)+strlen(name)];
+    sprintf(retName, "%s%s", tmpFileName, name+1);
+  }
+  else
+  {
+    retName = new char[strlen(name)+1];
+    strcpy(retName, name);
+  }
   return retName;
 }
@@ -874,13 +1001,13 @@
     return retName;
   else
-    {
-      delete[] retName;
-      return NULL;
-    }
-}
-
-
-/**
- * checks wether a file is in the DataDir.
+  {
+    delete[] retName;
+    return NULL;
+  }
+}
+
+
+/**
+ * @brief checks wether a file is in the DataDir.
  * @param fileName the File to check if it is in the Data-Dir structure.
  * @returns true if the file exists, false otherwise
@@ -893,5 +1020,5 @@
   bool retVal = false;
   char* checkFile = new char[strlen(ResourceManager::getInstance()->getDataDir())
-      + strlen(fileName) + 1];
+                             + strlen(fileName) + 1];
   sprintf(checkFile, "%s%s", ResourceManager::getInstance()->getDataDir(), fileName);
 
@@ -906,6 +1033,6 @@
 
 /**
- * outputs debug information about the ResourceManager
-*/
+ * @brief outputs debug information about the ResourceManager
+ */
 void ResourceManager::debug() const
 {
@@ -917,35 +1044,35 @@
   PRINT(0)(" Data-Directory is: %s\n", this->dataDir);
   PRINT(0)(" List of Image-Directories: ");
-  std::list<char*>::const_iterator imageDir;
+  std::vector<char*>::const_iterator imageDir;
   for (imageDir = this->imageDirs.begin(); imageDir != this->imageDirs.end(); imageDir++)
-      PRINT(0)("%s ", (*imageDir));
+    PRINT(0)("%s ", (*imageDir));
   PRINT(0)("\n");
 
   PRINT(0)("List of all stored Resources:\n");
-  std::list<Resource*>::const_iterator resource;
+  std::vector<Resource*>::const_iterator resource;
   for (resource = this->resourceList.begin(); resource != this->resourceList.end(); resource++)
 
-    {
-      PRINT(0)("-----------------------------------------\n");
-      PRINT(0)("Name: %s; References: %d; Type: %s ", (*resource)->name, (*resource)->count, ResourceManager::ResourceTypeToChar((*resource)->type));
-
-      PRINT(0)("gets deleted at ");
-      switch((*resource)->prio)
-        {
-        default:
-        case RP_NO:
-          PRINT(0)("first posibility (0)\n");
-          break;
-        case RP_LEVEL:
-          PRINT(0)("the end of the Level (1)\n");
-          break;
-        case RP_CAMPAIGN:
-          PRINT(0)("the end of the campaign (2)\n");
-          break;
-        case RP_GAME:
-          PRINT(0)("when leaving the game (3)\n");
-          break;
-        }
-    }
+  {
+    PRINT(0)("-----------------------------------------\n");
+    PRINT(0)("Name: %s; References: %d; Type: %s ", (*resource)->name, (*resource)->count, ResourceManager::ResourceTypeToChar((*resource)->type));
+
+    PRINT(0)("gets deleted at ");
+    switch((*resource)->prio)
+    {
+      default:
+      case RP_NO:
+        PRINT(0)("first posibility (0)\n");
+        break;
+      case RP_LEVEL:
+        PRINT(0)("the end of the Level (1)\n");
+        break;
+      case RP_CAMPAIGN:
+        PRINT(0)("the end of the campaign (2)\n");
+        break;
+      case RP_GAME:
+        PRINT(0)("when leaving the game (3)\n");
+        break;
+    }
+  }
 
 
@@ -956,5 +1083,5 @@
 
 /**
- * converts a ResourceType into the corresponding String
+ * @brief converts a ResourceType into the corresponding String
  * @param type the ResourceType to translate
  * @returns the converted String.
@@ -962,43 +1089,45 @@
 const char* ResourceManager::ResourceTypeToChar(ResourceType type)
 {
-  switch (type)
+  return ResourceManager::resourceNames[type];
+}
+
+/**
+ * @brief converts a String into a ResourceType (good for loading)
+ * @param resourceType the name of the Type
+ * @returns the Number of the Type, or 0 (defautl) if not found.
+ */
+ResourceType ResourceManager::stringToResourceType(const char* resourceType)
+{
+  assert(resourceType != NULL);
+  for (unsigned int i = 0; i < RESOURCE_TYPE_SIZE; i++)
+    if (!strcmp(resourceType, ResourceManager::resourceNames[i]))
+      return (ResourceType)i;
+  return (ResourceType)0;
+}
+
+/**
+ * The Names of the ResourceTypes
+ */
+const char* ResourceManager::resourceNames[] =
   {
 #ifndef NO_MODEL
-    case OBJ:
-      return "ObjectModel";
-      break;
-    case PRIM:
-      return "PrimitiveModel";
-      break;
-    case MD2:
-      return "MD2-Data";
-      break;
+    "ObjectModel",
+    "PrimitiveModel",
+    "MD2-Data",
+#endif
+#ifndef NO_TEXT
+    "Font",
+#endif
+#ifndef NO_AUDIO
+    "Wav",
+    "mp3",
+    "ogg",
 #endif
 #ifndef NO_TEXTURES
-    case IMAGE:
-      return "ImageFile (Texture)";
-      break;
-#endif
-#ifndef NO_AUDIO
-    case WAV:
-      return "SoundFile";
-      break;
-    case OGG:
-      return "MusicFile";
-      break;
-#endif
-#ifndef NO_TEXT
-    case TTF:
-      return "Font (TTF)";
-      break;
+    "Texture",
 #endif
 #ifndef NO_SHADERS
-    case SHADER:
-      return "Shader";
-      break;
+    "Shader",
 #endif
-    default:
-      return "unknown Format";
-      break;
-  }
-}
+
+  };
Index: /branches/network/src/util/loading/resource_manager.h
===================================================================
--- /branches/network/src/util/loading/resource_manager.h	(revision 6692)
+++ /branches/network/src/util/loading/resource_manager.h	(revision 6693)
@@ -14,4 +14,5 @@
     (NO_TEXT)
     (NO_TEXTURES)
+    (NO_SHADERS)
 */
 
@@ -20,7 +21,7 @@
 
 #include "base_object.h"
+#include "multi_type.h"
 
-
-#include <list>
+#include <vector>
 
 //! An eumerator for different fileTypes the resourceManager supports
@@ -46,4 +47,5 @@
   SHADER,               //!< openGL-shader program
 #endif /* NO_SHADERS */
+  RESOURCE_TYPE_SIZE
 };
 
@@ -73,17 +75,5 @@
   ResourcePriority  prio;              //!< The Priority of this resource. (This will only be increased)
 
-  // more specific
-  union {
-#ifndef NO_MODEL
-  float             modelSize;         //!< the size of the model (OBJ/PRIM)
-  char*             secFileName;       //!< a seconf fileName
-#endif /* NO_MODEL */
-#ifndef NO_TEXT
-  unsigned int      ttfSize;           //!< the size of the ttf-font (TTF)
-#endif /* NO_TEXT */
-#ifndef NO_TEXTURES
-  GLenum            texTarget;
-#endif /* NO_TEXTURES */
-  };
+  MultiType         param[3];          //!< The Parameters given to this Resource.
 };
 
@@ -114,14 +104,25 @@
   bool verifyDataDir(const char* fileInside);
   bool addImageDir(const char* imageDir);
+
+  bool cache(const char* fileName, ResourceType type, ResourcePriority prio = RP_NO,
+             const MultiType& param0 = MultiType(), const MultiType& param1 = MultiType(), const MultiType& param2 = MultiType());
+  BaseObject* copy(BaseObject* resourcePointer);
+
   BaseObject* load(const char* fileName, ResourcePriority prio = RP_NO,
-               void* param1 = NULL, void* param2 = NULL, void* param3 = NULL);
+                   const MultiType& param0 = MultiType(), const MultiType& param1 = MultiType(), const MultiType& param2 = MultiType());
   BaseObject* load(const char* fileName, ResourceType type, ResourcePriority prio = RP_NO,
-               void* param1 = NULL, void* param2 = NULL, void* param3 = NULL);
-  bool unload(void* pointer, ResourcePriority prio = RP_NO);
+                   const MultiType& param0 = MultiType(), const MultiType& param1 = MultiType(), const MultiType& param2 = MultiType());
+  bool unload(BaseObject* pointer, ResourcePriority prio = RP_NO);
   bool unload(Resource* resource, ResourcePriority = RP_NO);
   bool unloadAllByPriority(ResourcePriority prio);
 
-  Resource* locateResourceByInfo(const char* fileName, ResourceType type, void* param1, void* param2, void* param3) const;
+  Resource* locateResourceByInfo(const char* fileName, ResourceType type,
+                                 const MultiType& param0 = MultiType(), const MultiType& param1 = MultiType(), const MultiType& param2 = MultiType()) const;
   Resource* locateResourceByPointer(const void* pointer) const;
+
+  char* toResourcableString(unsigned int i);
+  bool fromResourceableString(const char* resourceableString);
+  /** @returns the Count of Resources the ResourceManager handles */
+  unsigned int resourceCount() const { return this->resourceList.size(); }
 
   void debug() const;
@@ -138,8 +139,10 @@
 
   static const char* ResourceTypeToChar(ResourceType type);
-
+  static ResourceType stringToResourceType(const char* resourceType);
 
  private:
   ResourceManager();
+  Resource* loadResource(const char* fileName, ResourceType type, ResourcePriority prio,
+                         const MultiType& param0, const MultiType& param1, const MultiType& param2);
 
  private:
@@ -147,7 +150,9 @@
 
   char*                    dataDir;            //!< The Data Directory, where all relevant Data is stored.
-  std::list<Resource*>     resourceList;       //!< The List of Resources, that has already been loaded.
-  std::list<char*>         imageDirs;          //!< A list of directories in which images are stored.
+  std::vector<char*>       imageDirs;          //!< A list of directories in which images are stored.
 
+  std::vector<Resource*>   resourceList;       //!< The List of Resources, that has already been loaded.
+
+  static const char*       resourceNames[RESOURCE_TYPE_SIZE];
 };
 
Index: /branches/network/src/world_entities/Makefile.am
===================================================================
--- /branches/network/src/world_entities/Makefile.am	(revision 6692)
+++ /branches/network/src/world_entities/Makefile.am	(revision 6693)
@@ -27,4 +27,5 @@
                   \
                   world_entities/weapons/weapon_manager.cc \
+                  world_entities/weapons/ammo_container.cc \
                   world_entities/weapons/weapon.cc \
                   world_entities/weapons/test_gun.cc \
@@ -51,4 +52,5 @@
                   world_entities/space_ships/space_ship.cc \
                   world_entities/space_ships/helicopter.cc \
+                  world_entities/space_ships/hover.cc \
                   world_entities/creatures/md2_creature.cc \
                   \
@@ -78,4 +80,5 @@
                  \
                  world_entities/weapons/weapon_manager.h \
+                 world_entities/weapons/ammo_container.h \
                  world_entities/weapons/weapon.h \
                  world_entities/weapons/test_gun.h \
@@ -102,4 +105,5 @@
                  world_entities/space_ships/space_ship.h \
                  world_entities/space_ships/helicopter.h \
+                 world_entities/space_ships/hover.h \
                  world_entities/creatures/md2_creature.h \
                  \
